=encoding utf8

=head1 NAME

Mail::Transport - use Mail Transfer Agents (MTAs)

=head1 INHERITANCE

 Mail::Transport
   is a Mail::Reporter

 Mail::Transport is extended by
   Mail::Transport::Receive
   Mail::Transport::Send

=head1 SYNOPSIS

  my $message = Mail::Message->new(...);

  # Some extensions implement sending:
  $message->send;
  $message->send(via => 'sendmail');

  my $sender = Mail::Transport::SMTP->new(...);
  $sender->send($message);

  # Some extensions implement receiving:
  my $receiver = Mail::Transport::POP3->new(...);
  $message = $receiver->receive;

=head1 DESCRIPTION

Objects which extend C<Mail::Transport> implement sending and/or
receiving of messages, using various protocols.

B<Be aware:>
This module versions 4.00 and up is not fully compatible with older releases:
mainly the exception handling has changed.  When you need to upgrade, please
read F<https://github.com/markov2/perl5-Mail-Box/wiki/>
B<Version 3 is still maintained> and may see new releases as well.

L<Mail::Transport::Send|Mail::Transport::Send> extends this class, and offers general
functionality for send protocols, like SMTP.  L<Mail::Transport::Receive|Mail::Transport::Receive>
also extends this class, and offers receive method.  Some transport
protocols will implement both sending and receiving.

Extends L<"DESCRIPTION" in Mail::Reporter|Mail::Reporter/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Reporter|Mail::Reporter/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Reporter|Mail::Reporter/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

Inherited, see L<Mail::Reporter/"Constructors">

 -Option    --Default
  executable  undef
  hostname    'localhost'
  interval    30
  password    undef
  port        undef
  proxy       undef
  retry       <unlimited>
  timeout     120
  username    undef
  via         'sendmail'

=over 2

=item executable => $file

If you specify an executable, the module does not need to search the
system directories to figure-out where the client lives.  Using this
decreases the flexible usage of your program: moving your program
to other systems may involve changing the path to the executable,
which otherwise would work auto-detect and unmodified.

=item hostname => $host|\@hosts

The C<$host> on which the server runs.  Some protocols accept an ARRAY
of alternatives for this option.

=item interval => $span

The time C<$span> between tries to contact the remote server for sending or
receiving a message in seconds.  This number must be larger than 0.

=item password => $password

Some protocols require a C<$password> to be given, usually in combination
with a password.

=item port => $port

The C<$port> number behind which the service is hiding on the remote server.

=item proxy => $path

The name of the proxy software (the protocol handler).  This must be
the name (preferable the absolute C<$path>) of your mail delivery
software.

=item retry => $count|undef

The number of retries before the sending will fail.  If C<undef>, the
number of retries is unlimited.

=item timeout => $span

The maximim seconds to wait for establishing the connection to a remote
server.

=item username => $username

Some protocols require a user to login.

=item via => CLASS|$name

Which CLASS (extending C<Mail::Transport>) will transport the data.
Some predefined names avoid long class names: C<mail> and C<mailx>
are handled by the L<Mail::Transport::Mailx|Mail::Transport::Mailx> module, C<sendmail>
and C<postfix> belong to L<Mail::Transport::Sendmail|Mail::Transport::Sendmail>, and C<smtp>
is implemented in L<Mail::Transport::SMTP|Mail::Transport::SMTP>.

The C<pop> or C<pop3> protocol implementation can be found distribution
L<Mail::Transport::POP3|Mail::Transport::POP3>.  For C<imap> or C<imap4>, install
L<Mail::Transport::IMAP4|Mail::Transport::IMAP4>.

=back

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Reporter|Mail::Reporter/"Attributes">.

=head2 Server connection

=over 4

=item $obj-E<gt>B<findBinary>( $name, [@directories] )

Look for a binary with the specified C<$name> in the directories which
are defined to be safe.  The list of standard directories is followed
by the optional C<@directories>.  The full pathname is returned.

You may specify L<new(proxy)|Mail::Transport/"METHODS">, which specifies the absolute name
of the binary to be used.

=item $obj-E<gt>B<remoteHost>()

Returns the hostname, port number, username and password to be used to
establish the connection to the server for sending or receiving mail.

=item $obj-E<gt>B<retry>()

Returns the retry interval, retry count, and timeout for the connection.

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Reporter|Mail::Reporter/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Reporter|Mail::Reporter/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: Avoid program abuse: specify an absolute path for $program.

Specifying explicit locations for executables of email transfer agents
should only be done with absolute file names, to avoid various pontential
security problems.
Cast by C<new()>

=item Error: Executable $program does not exist.

The explicitly indicated mail transfer agent does not exists. The normal
settings are used to find the correct location.
Cast by C<new()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=back

=head1 SEE ALSO

This module is part of Mail-Transport version 4.01,
built on December 13, 2025. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2025 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

